// ------------------------------------------------------------------------------------
// irr::core::array<u16> wrappers
// NOTES:
// did not wrap the const version of getLast()
// ------------------------------------------------------------------------------------

extern "C" array<u16>* IrrCore_Array_u16_new()
{
	return new array<u16>();
}

extern "C" array<u16>* IrrCore_Array_u16_newWithSize(u32 start_count)
{
	return new array<u16>(start_count);
}

extern "C" array<u16>* IrrCore_Array_u16_newFromOther(array<u16>* other)
{
	return new array<u16>(*other);
}

extern "C" void IrrCore_Array_u16_del(array<u16>* arr)
{
	if (arr)
		delete arr;
		
	arr=0;
}

extern "C" u32 IrrCore_Array_u16_allocated_size(array<u16>* arr)
{
	if (arr)
		return arr->allocated_size();
	else
		return 0;
}

extern "C" void IrrCore_Array_u16_clear(array<u16>* arr)
{
	if (arr)
		arr->clear();
}

extern "C" const u16* IrrCore_Array_u16_const_pointer(array<u16>* arr)
{
	if (arr)
		arr->const_pointer();
}

extern "C" u16* IrrCore_Array_u16_pointer(array<u16>* arr)
{
	if (arr)
		arr->pointer();
}

extern "C" bool IrrCore_Array_u16_empty(array<u16>* arr)
{
	if (arr)
		return arr->empty();
	else
		return true;
}

extern "C" void IrrCore_Array_u16_eraseWithCount(array<u16>* arr,u32 idx,s32 count)
{
	if (arr)
		arr->erase(idx,count);
}

extern "C" void IrrCore_Array_u16_erase(array<u16>* arr,u32 idx)
{
	if (arr)
		arr->erase(idx);
}

// do not delete this pointer
extern "C" u16* IrrCore_Array_u16_getLast(array<u16>* arr)
{
	if (arr)
		return &arr->getLast();
	else
		return 0;
}

// do not delete this pointer
extern "C" u16* IrrCore_Array_u16_elementAt(array<u16>* arr,u32 idx)
{
	if (arr)
		return &(*arr)[idx];
	else
		return 0;
}

extern "C" void IrrCore_Array_u16_insert(array<u16>* arr,u16* element,u32 idx=0)
{
	if (arr)
		arr->insert(*element,idx);
}

extern "C" void IrrCore_Array_u16_Eq(array<u16>* arr,array<u16>* other)
{
	if (arr)
		*arr=*other;
}

extern "C" void IrrCore_Array_u16_push_back(array<u16>* arr,u16* element)
{
	if (arr)
		arr->push_back(*element);
}

extern "C" void IrrCore_Array_u16_push_front(array<u16>* arr,u16* element)
{
	if (arr)
		arr->push_front(*element);
}

extern "C" void IrrCore_Array_u16_reallocate(array<u16>* arr,u32 new_size)
{
	if (arr)
		arr->reallocate(new_size);
}

extern "C" void IrrCore_Array_u16_set_free_when_destroyed(array<u16>* arr,bool f)
{
	if (arr)
		arr->set_free_when_destroyed(f);
}

extern "C" void IrrCore_Array_u16_set_pointer(array<u16>* arr,u16 newPointer[],u32 size)
{
	if (arr)
		arr->set_pointer(newPointer,size);
}

extern "C" void IrrCore_Array_u16_set_sorted(array<u16>* arr,bool bVal)
{
	if (arr)
		arr->set_sorted(bVal);
}

extern "C" void IrrCore_Array_u16_set_used(array<u16>* arr,bool bVal)
{
	if (arr)
		arr->set_used(bVal);
}

extern "C" u32 IrrCore_Array_u16_size(array<u16>* arr)
{
	if (arr)
		return arr->size();
	else
		return 0;
}

extern "C" s32 IrrCore_Array_u16_linear_reverse_search(array<u16>* arr,u16* find)
{
	if (arr)
		return arr->linear_reverse_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_u16_linear_search(array<u16>* arr,u16* find)
{
	if (arr)
		return arr->linear_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_u16_binary_search(array<u16>* arr,u16* find)
{
	if (arr)
		return arr->binary_search(*find);
	else
		return -1;
}

extern "C" s32 IrrCore_Array_u16_binary_searchWithBounds(array<u16>* arr,u16* find,s32 left,s32 right)
{
	if (arr)
		return arr->binary_search(*find,left,right);
	else
		return -1;
}

extern "C" void IrrCore_Array_u16_sort(array<u16>* arr)
{
	if (arr)
		arr->sort();
}


